// CubesView.h : interface of the CCubesView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CUBESVIEW_H__27B7088E_39C5_11D3_AD29_00A0247FB1F9__INCLUDED_)
#define AFX_CUBESVIEW_H__27B7088E_39C5_11D3_AD29_00A0247FB1F9__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "cortona.h"

class CCubesView : public CView
{
protected: // create from serialization only
    CCubesView();
    DECLARE_DYNCREATE(CCubesView)

// Attributes
public:
    CCubesDoc* GetDocument();

// Operations
public:

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CCubesView)
	public:
    virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	//}}AFX_VIRTUAL

// Implementation
public:
    virtual ~CCubesView();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif
    // Get translation filed from pSubsceneRoot
    bool GetEmbeddedTransform( INodeObject* pSubsceneRoot, INodeObject** embeddedTransform, char* objectName );
    bool GetTranslationField( INodeObject* pSubsceneRoot, ISFVec3fObject** ppTranslation );
    bool GetRotationField( INodeObject* pSubsceneRoot, ISFRotationObject** ppTranslation );
    bool GetScaleField( INodeObject* pSubsceneRoot, ISFVec3fObject** ppTranslation );
    bool GetChildrenField( INodeObject* pSubsceneRoot, IMFNodeObject** ppTranslation );
	bool GetLabelField( INodeObject* pSubsceneRoot, ISFStringObject** ppString );

	bool GetUrlField(INodeObject *pSubsceneRoot, IMFStringObject **ppurl);

    // Get material's field diffuseColor from pSubsceneRoot
    bool GetDiffuseColorField( INodeObject* pSubsceneRoot, ISFColorObject** ppDiffuseColor, char* name );
    bool GetEmissiveColorField( INodeObject* pSubsceneRoot, ISFColorObject** ppDiffuseColor, char* name );
	bool GetTransparencyField( INodeObject* pSubsceneRoot, ISFFloatObject** ppTransparency, char* name );
	bool GetScriptValue( INodeObject* pSubsceneRoot, ISFInt32Object** ppIn1, ISFInt32Object** ppIn2, ISFInt32Object** ppIn3, ISFInt32Object** ppIn4, char* name );
	bool GetMarkerLocation( INodeObject* pSubsceneRoot, ISFVec3fObject** ppMarker, char* name );
	void changeColor( ISFColorObject* color, ISFColorObject* color2 );
	bool TestNode( char* name, ISFFloatObject** ppTransparency );
protected:
	void SetEngine();
	CCortona m_wndCortona;

    IEngine* m_pEngine;
    ISFColorObject* m_pDiffuseColor;
    ISFVec3fObject* m_pTranslation;
	ISFFloatObject* m_pTransparency;

    bool m_bCubeInScene;

    // Create VRML node from textual representation
    bool CreateVrmlFromString( /*in*/ OLECHAR* szVrml, /*out*/ INodeObject** ppRoot );
    // Add subscene to the scene root
    bool AddToScene( INodeObject* pSubsceneRoot );

    void AddTransformString( /*in*/ OLECHAR* szVrml, char* label, char* defName, char* externalName );
	void loadInline( char* name );
	void loadMap( char* name );
	void presentLabel( char* text );
// Generated message map functions
protected:
    //{{AFX_MSG(CCubesView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnAddCube();
	afx_msg void OnRemoveCube();
	afx_msg void OnMoveUp();
	afx_msg void OnMoveDown();
	afx_msg void OnMoveRight();
	afx_msg void OnMoveLeft();
	afx_msg void OnMoveForward();
	afx_msg void OnMoveBackward();
	afx_msg void OnChangeColor();
	afx_msg void OnTaller();
	afx_msg void OnShorter();
	afx_msg void OnFatter();
	afx_msg void OnThinner();
	afx_msg void OnFadeOut();
	afx_msg void OnFadeIn();
	afx_msg void OnCycle();
	afx_msg void OnUpdateAddCube(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCubeInScene(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRotateLeft();
	afx_msg void OnRotateRight();
	afx_msg void OnRotateTowards();
	afx_msg void OnRotateAway();
	afx_msg void OnTwistLeft();
	afx_msg void OnTwistRight();
	afx_msg void OnJiggle();
	afx_msg void OnMoveToMarker();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in CubesView.cpp
inline CCubesDoc* CCubesView::GetDocument()
   { return (CCubesDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUBESVIEW_H__27B7088E_39C5_11D3_AD29_00A0247FB1F9__INCLUDED_)
