#define MAX_OBJECTS_TO_VIEW 100

class InfoViewManager {
public:
	InfoViewManager();
	void addObject( CCubesView* original, INodeObject* o, VisualObject* vo, char* defName, char* externalName );
	void scaleObjectX( int percent );
	void scaleObjectY( int percent );
	void scaleObjectZ( int percent );
	void scaleObject( int percent );
	void MoveUp();
	void MoveDown();
	void MoveRight();
	void MoveLeft();
	void MoveIn();
	void MoveOut();
	void Show();
	void Hide();
	void Cycle();
	void Taller() { scaleObjectY( 100 + scale_units ); }
	void Shorter() { scaleObjectY( 100 - scale_units ); }
	void Bigger() { scaleObject( 100 + scale_units ); }
	void Smaller() { scaleObject( 100 - scale_units ); }
	void FadeOut();
	void FadeIn();
	void Fatter() { scaleObjectZ( 100 + scale_units ); scaleObjectX( 100 + scale_units ); }
	void Thinner() { scaleObjectZ( 100 - scale_units ); scaleObjectX( 100 - scale_units ); }
	void SetMax( char* maxstr );
	void SetFadeUnits( char* valueStr );
	void SetScaleUnits( char* valueStr );
	void SetObject( char* name );
	void SetProperty( char* propertyName );
	void SetValue( char* value );
	void SetXmin( char* value );
	void SetXmax( char* value );
	void SetYmin( char* value );
	void SetYmax( char* value );
	void SetZmin( char* value );
	void SetZmax( char* value );
	void SetLabel( char* value );
	void RotateX();
	void RotateY();
	void RotateZ();
	void RotateXcc();
	void RotateYcc();
	void RotateZcc();
	void MarkX( char* objectName );
	void MarkY( char* objectName );
	void MarkZ( char* objectName );
	void MarkX( int idx );
	void MarkY( int idx );
	void MarkZ( int idx );
	void MarkX() { MarkX( markerIdx ); }
	void MarkY() { MarkY( markerIdx ); }
	void MarkZ() { MarkZ( markerIdx ); }
	void SpaceX( char* value );
	void SpaceY( char* value );
	void SpaceZ( char* value );
	void SetMarker() { markerIdx = currentIdx; }
	void Clear();
	ISFColorObject* getDiffuseColor() { return( colorList[ currentIdx ] ); }
	ISFColorObject* getEmissiveColor() { return( ecolorList[ currentIdx ] ); }
	void setTransparency( ISFFloatObject* t );
	char* getObjectAt( int offset );
	char* getCurrentObjectName() { return( getObjectAt( currentIdx )); }
	bool isVisible( int offset );
	float rescale( float value, int percent );
	IMFNodeObject* getGroup();
	void SetGroup();
	void ClearGroup();
	void saveState( FILE* fp );
	void loadState( FILE* fp, int version );
	void RegisterModelSet( char* name, int count );
	void ModelSwitch();
	void ForceModelSwitch();

	bool get3( char* line, float* x, float* y, float* z );
	void setLocation( int idx, float x, float y, float z );
	float getXlocation();
	float getYlocation();
	float getZlocation();
	void setScale( int idx, float x, float y, float z );
	void setTransparency( int idx, float value );
	void setDiffuseColor( int idx, float r, float g, float b );
	void setEmissiveColor( int idx, float r, float g, float b );
	void setRotation( int idx, float x, float y, float z, float angle );
	void setLabel( int idx, char* line );
	int getIdx( char* name );
	int lookup( char* name );
	void clearCurrentGroup();
	void setXlocation( float value );
	void setYlocation( float value );
	void setZlocation( float value );
	void setXscale( int ival );
	void setYscale( int ival );
	void setZscale( int ival );
	void setScale( int ival );
	void setRed( int ival );
	void setGreen( int ival );
	void setBlue( int ival );
	void setRotation( int ival );
	void setIn1( int ival );
	void setIn2( int ival );
	void setIn3( int ival );
	void setIn4( int ival );
	void linkObjects( char* object1, char* object2 );
	char* genCheckBoxes();
private:

	int markerIdx;      // object that has marker hit points
	int transformIdx;   // array offset of next available object storage location
	int currentIdx;     // the current object offset which all commands apply to
	int internalMax;    // size of the array for storing objects

	int fade_units;     // how quickly we fade away an image, 0-100 percent value range
	int scale_units;    // how quickly we increase or decrease scale of an object
	int location_units; // granularity of motion control

	char* currentProperty;  // where we apply value passed to generic "SetValue" method

	// remapping 0-65535 into actual values
	float xMin;
	float xMax;
	float yMin;
	float yMax;
	float zMin;
	float zMax;

	char* currentGroup;
	VisualObject* visualObjects[ MAX_OBJECTS_TO_VIEW ];
	bool visible[MAX_OBJECTS_TO_VIEW];  // tracks whether a particular object is visible
	ISFColorObject* colorList[MAX_OBJECTS_TO_VIEW];
	ISFColorObject* ecolorList[MAX_OBJECTS_TO_VIEW];
	ISFVec3fObject* scaleList[MAX_OBJECTS_TO_VIEW];
	ISFFloatObject* transparencyList[ MAX_OBJECTS_TO_VIEW ];
	ISFRotationObject* rotationList[ MAX_OBJECTS_TO_VIEW ];
	char* transformNameList[MAX_OBJECTS_TO_VIEW];
	int value[MAX_OBJECTS_TO_VIEW];
	bool gotMaterial[ MAX_OBJECTS_TO_VIEW ];
};