#include "stdafx.h"

#include <stdio.h>
#include <io.h>
#include <winsock2.h>
#include "MindtelSocket.h"
#include "log.h"
#include "FormValues.h"

class TidesServerLoader {
public:
	TidesServerLoader();
	char* getServerName() { return( serverName ); }
	int getServerPort() { return( serverPort ); }
	char* getServerPage() { return( serverPage ); }
	char* getServerCommand() { return( serverCommand ); }
private:
	char* serverName;
	int serverPort;
	char* serverPage;
	char* serverCommand;
};

class NeatviewConfigLoader {
public:
	NeatviewConfigLoader();
	int simulateTidesSearch() { return( simulateTidesFlag ); }
	int simulatedSearchResults() { return( simulatedResultsValue ); }
private:
	int simulateTidesFlag;
	int simulatedResultsValue;
};

NeatviewConfigLoader neatviewConfig;
NeatviewConfigLoader::NeatviewConfigLoader() {
	simulateTidesFlag = 0;
	simulatedResultsValue = 0;
	FILE* fp = fopen( "neatview.config", "r" );
	if ( fp != NULL ) {
		char* x = file_line( fp );
		if ( x != NULL ) {
			simulateTidesFlag = atoi( x );
		}
		x = file_line( fp );
		if (x != NULL ) {
			simulatedResultsValue = atoi( x );
		}
		fclose( fp );
	}
}

TidesServerLoader tidesServer;

TidesServerLoader::TidesServerLoader() {
	// the initial defaults direct from Kapil's example
	serverName = "objectrealms.net";
	serverPort = 10000;
	serverPage = "/RPC2";
	serverCommand = "search";
	FILE* fp = fopen( "tides.config", "r" );
	if ( fp != NULL ) {
		serverName = file_line( fp );
		char* x = file_line( fp );
		if ( x != NULL ) {
			serverPort = atoi( x );
		}
		x = file_line( fp );
		if ( x != NULL ) {
			serverPage = x;
		}
		fclose( fp );
	}
	log_message1( "Tides Server: ", serverName );
	log_messagei1( "Tides Server Port: ", serverPort );
}

char* param( char* name, char* value ) {
	char pbuf[1000];
	sprintf( pbuf, "<member><name>%s</name><value><string>%s</string></value></member>", name, value );
	return( newstrcpy( pbuf ));
}

char latestSearch[1000];
char* get_latest_search() {
	return( newstrcpy( latestSearch ));
}

int tides_search( FormValues* fv ) {
	char parambuf[2000];
	parambuf[0] = 0;
	int numberValues = 0;
	latestSearch[0] = 0;
	for ( int i = 0; i < fv->getNumberValues(); i++ ) {
		char* value = fv->getValue( i );
		if ( strlen( value ) > 0 ) {
			numberValues++;
			strcat( parambuf, param( fv->getName( i ), fv->getValue( i )));
			char tbuf[200];
			sprintf( tbuf, "%s: %s<br>\n", fv->getName(i), fv->getValue(i));
			strcat( latestSearch, tbuf );
		}
	}
	if ( neatviewConfig.simulateTidesSearch() ) {
		return( neatviewConfig.simulatedSearchResults() );
	}
	if ( numberValues > 0 ) {
		//log_message1( "Tides server: ", tidesServer.getServerName() );
		//log_messagei1( "Tides port: ", tidesServer.getServerPort() );
		MindtelSocketClient client( tidesServer.getServerName(), tidesServer.getServerPort() );
		if ( client.Connect() ) {
			log_message( "We connected to tides server" );
			int x = client.tidesXmlRpc( tidesServer.getServerPage(), 
				tidesServer.getServerCommand(), &parambuf[0] );
			//log_messagei1( "Tides search result is: ", x );
			return( x );
		} else {
			log_message( "We failed to connect to tides server" );
		}
	} else {
		log_message( "form has no values for us to search on" );
	}
	return( 0 );
}

void complexSearch( CString s ) {
	MindtelSocketClient client( "objectrealms.net", 10000 );
	if ( client.Connect() ) {
		int x = client.tidesXmlRpc( "/RPC2", "search", param( "Persons", s.GetBuffer( 100 )));
		log_messagei1("Result of search is:", x );
/*		imv.SetObject("cylinder");
		imv.SetLabel( s.GetBuffer(100));
		imv.setYscale( x*1000 );
		imv.MarkX();
		imv.MarkZ();
		imv.ForceModelSwitch();*/
	}
}
