#include "cortona.h"

class VisualObject {
public:
	VisualObject( INodeObject* transformNode );
	void SetScriptInputs( ISFInt32Object* in1, ISFInt32Object* in2, ISFInt32Object* in3, ISFInt32Object* in4, ISFInt32Object* in5 );
	ISFInt32Object* getIn1() { return( script_in1 ); }
	ISFInt32Object* getIn2() { return( script_in2 ); }
	ISFInt32Object* getIn3() { return( script_in3 ); }
	ISFInt32Object* getIn4() { return( script_in4 ); }
	void SetEmbeddedTransform( INodeObject* xform );
	void SetScale( ISFVec3fObject* s ) { pScale = s; }
	ISFVec3fObject* getScale() { return( pScale ); }
	void SetRotation( ISFRotationObject* r ) { pRotation = r; }
	ISFRotationObject* getRotation() { return( pRotation ); }
	INodeObject* getTransform() { return( pTransformNode ); }
	IMFNodeObject* getGroup() { return( pGroup ); }
	void SetGroup( IMFNodeObject* g ) { pGroup = g; }
	void SetLabel( ISFStringObject* l ) { pLabel = l; }
	ISFStringObject* getLabel() { return( pLabel ); }
	void setLabel( char* label );
	char* getLabelString() { return( labelString ); }
	void setLabelString( char* ls );
	void SetMarkerLocation( ISFVec3fObject* m ) { pMarker = m; }
	ISFVec3fObject* getMarkerLocation() { return( pMarker ); }
	void setNextLink( VisualObject* n ) { next = n; }
	void scaleBaseLocation( float base );
	void scaleNextBaseLocation( float base );

	void setLocation( ISFVec3fObject* l ) { pLocation = l; }
	void setTranslation( ISFVec3fObject* t ) { pTranslation = t; }
	ISFVec3fObject* getTranslation() { return( pTranslation ); }

private:
	INodeObject* pTransformNode;  // root of this hierarchy
	IMFNodeObject* pGroup;        // "children" element of the above Transform node
	ISFStringObject* pLabel;      // transform label field for eventIn (optional)

	ISFInt32Object* script_in1;   // integer inputs for script node
	ISFInt32Object* script_in2;
	ISFInt32Object* script_in3;
	ISFInt32Object* script_in4;
	ISFInt32Object* script_in5;

	INodeObject* embeddedTransform;

	ISFVec3fObject* pScale;
	ISFRotationObject* pRotation;
	ISFVec3fObject* pMarker;
	ISFVec3fObject* pLocation;
	ISFVec3fObject* pTranslation;

	float base_x;
	float base_y;
	float base_z;
	bool base_set;

	char* labelString;

	VisualObject* children; // first child
	VisualObject* next;     // next in linked list
};
